SystemOrganization addCategory: #BICHOS!

Object subclass: #BichoGeneral
	instanceVariableNames: 'nivelVida ubicacion'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BICHOS'!

!BichoGeneral methodsFor: 'as yet unclassified' stamp: 'Federico 11/1/2015 12:35'!
atacarA: unIntruso

	self moveteA: unIntruso ubicacion.
	
	unIntruso recibirDaño: self.
! !

!BichoGeneral methodsFor: 'as yet unclassified' stamp: 'Federico 11/1/2015 13:41'!
muerteInstantanea

	self nivelVida: self nivelVida - 10! !

!BichoGeneral methodsFor: 'as yet unclassified' stamp: 'Federico 11/1/2015 11:52'!
nivelVida

	^ nivelVida! !

!BichoGeneral methodsFor: 'as yet unclassified' stamp: 'Federico 11/1/2015 11:53'!
nivelVida: anObject

	nivelVida := anObject! !

!BichoGeneral methodsFor: 'as yet unclassified' stamp: 'Federico 11/1/2015 13:36'!
recibirDaño: unBicho

	self vida: (self restarVida: unBicho).! !

!BichoGeneral methodsFor: 'as yet unclassified' stamp: 'Federico 11/1/2015 13:36'!
restarVida: unBicho

	^self nivelVida - (unBicho nivelAtaque)  max:0.! !

!BichoGeneral methodsFor: 'as yet unclassified' stamp: 'Federico 11/1/2015 13:16'!
ubicacion
	
	^ ubicacion.! !

!BichoGeneral methodsFor: 'as yet unclassified' stamp: 'Federico 11/1/2015 13:38'!
ubicacion: unEspacio

	ubicacion:= unEspacio.
	! !

BichoGeneral subclass: #Hormiga
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BICHOS'!

!Hormiga methodsFor: 'as yet unclassified' stamp: 'Federico 11/1/2015 14:44'!
estado
	^ estado! !

!Hormiga methodsFor: 'as yet unclassified' stamp: 'Federico 11/1/2015 14:44'!
estado: anObject
	estado := anObject! !

!Hormiga methodsFor: 'as yet unclassified' stamp: 'Federico 11/1/2015 13:31'!
moveteA: unaUbicacion

	(self estado) moveteA:unaUbicacion una: self.! !

!Hormiga methodsFor: 'as yet unclassified' stamp: 'Federico 11/1/2015 13:26'!
muerta

	self estado: EstadoMuerta new.
	
	
	self hormiguero removerMuerta: self.! !

Hormiga subclass: #HormigaQueNoSeMueve
	instanceVariableNames: 'estado'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BICHOS'!

!HormigaQueNoSeMueve methodsFor: 'as yet unclassified' stamp: 'Federico 11/1/2015 13:51'!
distanciaEstado

	^0! !

!HormigaQueNoSeMueve methodsFor: 'as yet unclassified' stamp: 'Federico 11/1/2015 13:51'!
distanciaRecorrida

	^0.! !

!HormigaQueNoSeMueve methodsFor: 'as yet unclassified' stamp: 'Federico 11/1/2015 13:29'!
esViolenta

	^false.! !

!HormigaQueNoSeMueve methodsFor: 'as yet unclassified' stamp: 'Federico 11/1/2015 14:44'!
initialize

	estado := EstadoViva  new.
	
	ubicacion := Ubicacion new.! !

!HormigaQueNoSeMueve methodsFor: 'as yet unclassified' stamp: 'Federico 11/1/2015 02:29'!
nivelAtaque
	^0.! !

!HormigaQueNoSeMueve methodsFor: 'as yet unclassified' stamp: 'Federico 11/1/2015 13:36'!
recibirDaño: unInsecto

	self muerta! !

HormigaQueNoSeMueve subclass: #HormigaReina
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BICHOS'!

!HormigaReina methodsFor: 'as yet unclassified' stamp: 'Federico 11/1/2015 13:28'!
alLimite
	^false.! !

!HormigaReina methodsFor: 'as yet unclassified' stamp: 'Federico 11/1/2015 02:26'!
comidaQueLleva
	^0.! !

HormigaQueNoSeMueve subclass: #HormigaZangano
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BICHOS'!

!HormigaZangano methodsFor: 'as yet unclassified' stamp: 'Federico 11/1/2015 13:28'!
alLimite

	^true.! !

!HormigaZangano methodsFor: 'as yet unclassified' stamp: 'Federico 11/1/2015 14:19'!
almacenarComidaEn: unHormiguero

	unHormiguero agregarComida: (self comidaQueLleva).
	
! !

!HormigaZangano methodsFor: 'as yet unclassified' stamp: 'Federico 11/1/2015 02:26'!
comidaQueLleva

	^1.! !

!HormigaZangano methodsFor: 'as yet unclassified' stamp: 'Federico 11/1/2015 14:17'!
extraerAlimentoDe: unaComida

	self moveteA: (unaComida ubicacion).
	
	self estado extraerDe: unaComida con: self.


	

	! !

!HormigaZangano methodsFor: 'as yet unclassified' stamp: 'Federico 11/1/2015 14:18'!
llevarAlimentoA: unHormiguero

	self estado llevarAlimentoA: unHormiguero con: self.! !

Hormiga subclass: #HormigaQueSeMueve
	instanceVariableNames: 'hormiguero comidaQueLleva estado ubicacionesPorLasQuePaso distanciasTotales cantidadDeUbicacionesPorLasQuePaso distanciaRecorrida cantidadDeRecorridos distanciaEstado'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BICHOS'!

HormigaQueSeMueve subclass: #HormigaObrera
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BICHOS'!

!HormigaObrera methodsFor: 'as yet unclassified' stamp: 'Federico 11/1/2015 02:19'!
alLimite
	
	^ (self comidaQueLleva >= 9) & (self comidaQueLleva <=10).! !

!HormigaObrera methodsFor: 'as yet unclassified' stamp: 'Federico 11/1/2015 14:20'!
almacenarComidaEn: unHormiguero

	unHormiguero agregarComida: (self comidaQueLleva).
	
	self entregarAlimento.
! !

!HormigaObrera methodsFor: 'as yet unclassified' stamp: 'Federico 11/1/2015 13:49'!
comidaQueLleva

	^ comidaQueLleva ! !

!HormigaObrera methodsFor: 'as yet unclassified' stamp: 'Federico 11/1/2015 13:49'!
comidaQueLleva: anObject

	comidaQueLleva := anObject.! !

!HormigaObrera methodsFor: 'as yet unclassified' stamp: 'Federico 11/1/2015 14:19'!
entregarAlimento

	self comidaQueLleva: 0.! !

!HormigaObrera methodsFor: 'as yet unclassified' stamp: 'Federico 11/1/2015 12:18'!
esViolenta

	^false.! !

!HormigaObrera methodsFor: 'as yet unclassified' stamp: 'Federico 11/1/2015 14:17'!
extraerAlimentoDe: unaComida

	self moveteA: (unaComida ubicacion).
	
	self estado extraerDe: unaComida con: self.


	

	! !

!HormigaObrera methodsFor: 'as yet unclassified' stamp: 'Federico 11/1/2015 14:35'!
initialize

	super initialize.
	
	comidaQueLleva:= 0.
	! !

!HormigaObrera methodsFor: 'as yet unclassified' stamp: 'Federico 11/1/2015 14:18'!
llevarAlimentoA: unHormiguero

	self estado llevarAlimentoA: unHormiguero con: self.! !

!HormigaObrera methodsFor: 'as yet unclassified' stamp: 'Federico 11/1/2015 02:29'!
nivelAtaque

	^2! !

!HormigaObrera methodsFor: 'as yet unclassified' stamp: 'Federico 11/1/2015 14:32'!
puedeLlevar

	^(self estado) puedeLlevarConEstado: self.! !

!HormigaObrera methodsFor: 'as yet unclassified' stamp: 'Federico 11/1/2015 14:31'!
recibirDaño: unaCantidad
	
	self muerta.! !

!HormigaQueSeMueve methodsFor: 'as yet unclassified' stamp: 'Federico 11/1/2015 12:08'!
a500cmDe: unaUbicacion

	^ ((self ubicacion )distanciaA: unaUbicacion)<0.5 ! !

!HormigaQueSeMueve methodsFor: 'as yet unclassified' stamp: 'Federico 10/27/2015 23:08'!
cansada
	
	self estado: EstadoCansada new.! !

!HormigaQueSeMueve methodsFor: 'as yet unclassified' stamp: 'Federico 10/30/2015 23:07'!
cantidadDeRecorridos

	^ cantidadDeRecorridos! !

!HormigaQueSeMueve methodsFor: 'as yet unclassified' stamp: 'Federico 10/30/2015 23:08'!
cantidadDeRecorridos: anObject

	cantidadDeRecorridos:= anObject! !

!HormigaQueSeMueve methodsFor: 'as yet unclassified' stamp: 'Federico 10/26/2015 17:52'!
comidaQueFaltaParaLlegarAlLimite

	^ 10 - self comidaQueLleva.! !

!HormigaQueSeMueve methodsFor: 'as yet unclassified' stamp: 'Federico 10/26/2015 19:01'!
comidaQueLleva

	^ comidaQueLleva.! !

!HormigaQueSeMueve methodsFor: 'as yet unclassified' stamp: 'Federico 10/26/2015 17:54'!
comidaQueLleva: anObject

	comidaQueLleva:= anObject! !

!HormigaQueSeMueve methodsFor: 'as yet unclassified' stamp: 'Federico 10/31/2015 22:28'!
comidaQuePuedeLlevar

	^((self estado) comidaEstado - self comidaQueLleva) ! !

!HormigaQueSeMueve methodsFor: 'as yet unclassified' stamp: 'Federico 10/31/2015 23:25'!
descansa

	estado cambiarEstado: self.
	! !

!HormigaQueSeMueve methodsFor: 'as yet unclassified' stamp: 'Federico 10/28/2015 23:01'!
distancia: unaUbicacion
	
	^ self ubicacion dist: unaUbicacion ubicacion.! !

!HormigaQueSeMueve methodsFor: 'as yet unclassified' stamp: 'Federico 10/31/2015 22:30'!
distanciaEstado
	^distanciaEstado! !

!HormigaQueSeMueve methodsFor: 'as yet unclassified' stamp: 'Federico 10/31/2015 22:30'!
distanciaEstado: anObject
	distanciaEstado :=  anObject! !

!HormigaQueSeMueve methodsFor: 'as yet unclassified' stamp: 'Federico 10/31/2015 01:44'!
distanciaPromedio

	^ (self distanciaRecorrida) / (self cantidadDeRecorridos).! !

!HormigaQueSeMueve methodsFor: 'as yet unclassified' stamp: 'Federico 10/29/2015 00:06'!
distanciaPromedioUltimasUbicaciones: unaCantidad

	^ (self distanciaRecorridaUltimasUbicaciones: unaCantidad)/ unaCantidad.! !

!HormigaQueSeMueve methodsFor: 'as yet unclassified' stamp: 'Federico 10/28/2015 22:48'!
distanciaRecorrida
	
	^distanciaRecorrida.! !

!HormigaQueSeMueve methodsFor: 'as yet unclassified' stamp: 'Federico 10/29/2015 22:48'!
distanciaRecorrida: anObject

	distanciaRecorrida := anObject! !

!HormigaQueSeMueve methodsFor: 'as yet unclassified' stamp: 'Federico 10/31/2015 01:48'!
distanciaRecorridaUltimasUbicaciones: unaCantidad
	
	^ (self ubicacionesPorLasQuePaso last: unaCantidad) sum.! !

!HormigaQueSeMueve methodsFor: 'as yet unclassified' stamp: 'Federico 10/27/2015 22:46'!
distanciasTotales
	^distanciasTotales.! !

!HormigaQueSeMueve methodsFor: 'as yet unclassified' stamp: 'Federico 10/31/2015 23:45'!
initialize

	comidaQueLleva:= 0.
	distanciaRecorrida := 0.
	cantidadDeRecorridos := 0.
	ubicacionesPorLasQuePaso := Set new.
	ubicacion := Ubicacion new.
	estado := EstadoNormal new.
	! !

!HormigaQueSeMueve methodsFor: 'as yet unclassified' stamp: 'Federico 10/27/2015 22:57'!
limiteDisponible

	^ 10 - comidaQueLleva.! !

!HormigaQueSeMueve methodsFor: 'as yet unclassified' stamp: 'Federico 10/31/2015 22:39'!
normalizada

	(self comidaQueLleva  > 10) ifTrue:[ self comidaQueLleva: 10].
	
	
	self estado: EstadoNormal new.! !

!HormigaQueSeMueve methodsFor: 'as yet unclassified' stamp: 'Federico 10/31/2015 22:37'!
normalizar

	((self distanciaAcumulada) > 5) ifTrue: [self normalizada].! !

!HormigaQueSeMueve methodsFor: 'as yet unclassified' stamp: 'Federico 10/31/2015 01:10'!
sumarDistanciaRecorridaA: unaUbicacion1

	self distanciaRecorrida: ((self distanciaRecorrida) + ((self ubicacion) distanciaA: unaUbicacion1))! !

!HormigaQueSeMueve methodsFor: 'as yet unclassified' stamp: 'Federico 10/31/2015 22:42'!
sumarDistanciasEstado: unaUbicacion

	self distanciaEstado:  (self distanciaEstado  + ((self ubicacion) distanciaA: unaUbicacion)).! !

!HormigaQueSeMueve methodsFor: 'as yet unclassified' stamp: 'Federico 10/30/2015 23:20'!
sumarRecorridos

	self cantidadDeRecorridos: self cantidadDeRecorridos  + 1.! !

!HormigaQueSeMueve methodsFor: 'as yet unclassified' stamp: 'Federico 10/30/2015 23:10'!
sumarViajes

	self cantidadDeRecorridos: self cantidadDeRecorridos  + 1.! !

!HormigaQueSeMueve methodsFor: 'as yet unclassified' stamp: 'Federico 10/27/2015 22:25'!
ubicacionesPorLasQuePaso

	^ ubicacionesPorLasQuePaso.! !

!HormigaQueSeMueve methodsFor: 'as yet unclassified' stamp: 'Federico 10/30/2015 23:07'!
ubicacionesPorLasQuePaso: anObject

	ubicacionesPorLasQuePaso:= anObject! !

!HormigaQueSeMueve methodsFor: 'as yet unclassified' stamp: 'Federico 10/28/2015 23:17'!
ultimasUbicacionesPorLasQuePaso: unaCantidad

	^self ubicacionesPorLasQuePaso last: unaCantidad.! !

HormigaQueSeMueve subclass: #HormigaSoldado
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BICHOS'!

!HormigaSoldado methodsFor: 'as yet unclassified' stamp: 'Federico 11/1/2015 02:12'!
alLimite
	^ false! !

!HormigaSoldado methodsFor: 'as yet unclassified' stamp: 'Federico 11/1/2015 02:05'!
comidaQueLleva
	^0! !

!HormigaSoldado methodsFor: 'as yet unclassified' stamp: 'Federico 11/1/2015 13:42'!
descansa

	super descansa
	
	self vida: 20.! !

!HormigaSoldado methodsFor: 'as yet unclassified' stamp: 'Federico 11/1/2015 12:18'!
esViolenta

	^true.! !

!HormigaSoldado methodsFor: 'as yet unclassified' stamp: 'Federico 11/1/2015 14:35'!
initialize 


	super initialize.
	
	nivelVida:=20.! !

!HormigaSoldado methodsFor: 'as yet unclassified' stamp: 'Federico 11/1/2015 02:29'!
nivelAtaque

	^5.! !

!HormigaSoldado methodsFor: 'as yet unclassified' stamp: 'Federico 11/1/2015 14:15'!
recibirDaño: unInsecto

	super recibirDaño: unInsecto.
	
		
	(self nivelVida = 0) ifTrue:[ self muerta].
! !

BichoGeneral subclass: #Langosta
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BICHOS'!

!Langosta methodsFor: 'as yet unclassified' stamp: 'Federico 11/1/2015 13:37'!
initialize
	nivelVida:=50.! !

Object subclass: #Colonia
	instanceVariableNames: 'hormigueros'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BICHOS'!

!Colonia methodsFor: 'as yet unclassified' stamp: 'Federico 11/1/2015 16:00'!
agregarHormiguero: unHormiguero

		self hormigueros add: unHormiguero.! !

!Colonia methodsFor: 'as yet unclassified' stamp: 'Federico 11/1/2015 16:02'!
cantidadDeHormigasTotales

	self hormiguero sum:[:unHormiguero| unHormiguero hormigasTotales ]! !

!Colonia methodsFor: 'as yet unclassified' stamp: 'Federico 11/1/2015 16:18'!
defenderseDelIntruso:unIntruso

	[self tieneA: unIntruso] ifFalse:[
	self hormigueros do:[:hormiguero|hormiguero defenderseDeIntruso: unIntruso]
	].! !

!Colonia methodsFor: 'as yet unclassified' stamp: 'Federico 11/1/2015 15:56'!
hormigueros

	^hormigueros! !

!Colonia methodsFor: 'as yet unclassified' stamp: 'Federico 11/1/2015 15:56'!
hormigueros: anObject


	hormigueros := anObject! !

!Colonia methodsFor: 'as yet unclassified' stamp: 'Federico 11/1/2015 16:25'!
juntarAlimento


		self hormigueros do:[:unHormiguero| unHormiguero juntarAlimento]! !

!Colonia methodsFor: 'as yet unclassified' stamp: 'Federico 11/1/2015 16:16'!
tieneA:unBicho


	^self hormigueros anySatisfy: [ :hormiguero|hormiguero tieneA: unBicho].! !

Object subclass: #Comida
	instanceVariableNames: 'masa ubicacion'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BICHOS'!

Comida subclass: #Alfajor
	instanceVariableNames: 'chipsChocolate chips'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BICHOS'!

!Alfajor methodsFor: 'as yet unclassified' stamp: 'Federico 10/31/2015 12:38'!
chipsChocolate: anObject

	chips := anObject.
	masa := chips * 20! !

!Alfajor methodsFor: 'as yet unclassified' stamp: 'Federico 10/31/2015 12:41'!
initialize

	self chipsChocolate: 0! !

!Comida methodsFor: 'as yet unclassified' stamp: 'Federico 10/31/2015 11:46'!
actualizarMasa: unaCantidad


	self masa: self masa - unaCantidad - 1! !

!Comida methodsFor: 'as yet unclassified' stamp: 'Federico 10/31/2015 11:49'!
comidaEsExtraible

 	self masa = 0
	
		ifFalse: [ ^true.]
			
		ifTrue: [self error: 'no se puede extraer mas comida']
	! !

!Comida methodsFor: 'as yet unclassified' stamp: 'Federico 10/29/2015 23:04'!
masa
	^ masa! !

!Comida methodsFor: 'as yet unclassified' stamp: 'Federico 10/29/2015 23:04'!
masa: anObject
	masa:= anObject! !

!Comida methodsFor: 'as yet unclassified' stamp: 'Federico 10/29/2015 23:04'!
ubicacion

	^ ubicacion
! !

!Comida methodsFor: 'as yet unclassified' stamp: 'Federico 10/29/2015 23:05'!
ubicacion: unaUbicacion

	ubicacion := unaUbicacion.! !

Object subclass: #EstadoCansada
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BICHOS'!

!EstadoCansada methodsFor: 'as yet unclassified' stamp: 'Federico 10/31/2015 23:04'!
cambiarEstado: unaHormiga

	unaHormiga estado: EstadoNormal new.
	! !

!EstadoCansada methodsFor: 'as yet unclassified' stamp: 'Federico 10/31/2015 23:06'!
extraerDe: unaComida con: unaHormiga! !

!EstadoCansada methodsFor: 'as yet unclassified' stamp: 'Federico 10/31/2015 23:08'!
llevarAlimentoA: unHormiguero con: unaHormiga! !

!EstadoCansada methodsFor: 'as yet unclassified' stamp: 'Federico 10/31/2015 23:06'!
moveteA: unaUbicacion1 una: hormigaAfectada! !

Object subclass: #EstadoMuerta
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BICHOS'!

!EstadoMuerta methodsFor: 'as yet unclassified' stamp: 'Federico 11/1/2015 11:30'!
comidaEstado

	 ^0! !

!EstadoMuerta methodsFor: 'as yet unclassified' stamp: 'Federico 11/1/2015 11:32'!
extraerDe: unaComida con: unaHormiga

	self error: 'La hormiga esta muerta, no puede realizar esta accion'.! !

!EstadoMuerta methodsFor: 'as yet unclassified' stamp: 'Federico 11/1/2015 11:33'!
llevarAlimentoA: unHormiguero con: unaHormiga

	self error:'La hormiga esta muerta, no puede realizar esta accion'.! !

!EstadoMuerta methodsFor: 'as yet unclassified' stamp: 'Federico 11/1/2015 11:37'!
moveteA: unaUbicacion1 una: hormigaAfectada


	self error: 'La hormiga esta muerta, no puede realizar esta accion'.
! !

!EstadoMuerta methodsFor: 'as yet unclassified' stamp: 'Federico 11/1/2015 11:37'!
puedeLlevarConEstado: unaHormiga

	self error: 'La hormiga esta muerta, no puede realizar esta accion'.
! !

Object subclass: #EstadoNormal
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BICHOS'!

EstadoNormal subclass: #EstadoExaltada
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BICHOS'!

!EstadoExaltada methodsFor: 'as yet unclassified' stamp: 'Federico 10/31/2015 22:55'!
cambiarEstado: unaHormiga
! !

!EstadoExaltada methodsFor: 'as yet unclassified' stamp: 'Federico 10/31/2015 23:16'!
comidaEstado

	 ^20! !

!EstadoExaltada methodsFor: 'as yet unclassified' stamp: 'Federico 10/31/2015 23:02'!
extraerDe: unaComida con: unaHormiga

	super extraerDe: unaComida con: unaHormiga.
	unaHormiga comidaQueLleva:20.! !

!EstadoExaltada methodsFor: 'as yet unclassified' stamp: 'Federico 10/31/2015 23:02'!
moveteA: unaUbicacion1 una: hormigaAfectada
	
	hormigaAfectada sumarDistanciasEstado: unaUbicacion1.
	hormigaAfectada normalizada.
	super moveteA: unaUbicacion1 una: hormigaAfectada.
	! !

!EstadoExaltada methodsFor: 'as yet unclassified' stamp: 'Federico 10/31/2015 22:55'!
puedeLlevarConEstado: unaHormiga

	^(unaHormiga comidaQueLleva <= 20).! !

!EstadoNormal methodsFor: 'as yet unclassified' stamp: 'Federico 10/31/2015 22:48'!
cambiarEstado: unaHormiga

	unaHormiga estado: EstadoExaltada new.
	
	unaHormiga distanciaEstado: 0.! !

!EstadoNormal methodsFor: 'as yet unclassified' stamp: 'Federico 10/31/2015 23:16'!
comidaEstado

	 ^10! !

!EstadoNormal methodsFor: 'as yet unclassified' stamp: 'Federico 10/31/2015 15:17'!
extraerDe: unaComida con: unaHormiga
	
	
	((unaComida comidaEsExtraible) and: (unaHormiga puedeLlevar)) 
	
	ifTrue:[	
			unaComida actualizarMasa: (unaHormiga comidaQuePuedeLlevar). 
			unaHormiga comidaQueLleva: 10.
			]. ! !

!EstadoNormal methodsFor: 'as yet unclassified' stamp: 'Federico 10/31/2015 02:20'!
llevarAlimentoA: unHormiguero con: unaHormiga

	unaHormiga moveteA: (unHormiguero ubicacion).
	
	unaHormiga almacenarComidaEn: unHormiguero! !

!EstadoNormal methodsFor: 'as yet unclassified' stamp: 'Federico 10/31/2015 16:00'!
moveteA: unaUbicacion1 una: hormigaAfectada
	|ubicacionAnterior|
	hormigaAfectada ubicacionesPorLasQuePaso add: unaUbicacion1.
	hormigaAfectada sumarViajes.
	hormigaAfectada sumarDistanciaRecorridaA: unaUbicacion1.
	hormigaAfectada ubicacion: unaUbicacion1.
	ubicacionAnterior := hormigaAfectada ubicacion.
	((ubicacionAnterior distanciaA: unaUbicacion1) > 10) ifTrue: [hormigaAfectada cansada].
		
	! !

!EstadoNormal methodsFor: 'as yet unclassified' stamp: 'Federico 10/31/2015 23:07'!
puedeLlevarConEstado: unaHormiga

	^(unaHormiga comidaQueLleva <= 10).! !

Object subclass: #EstadoViva
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BICHOS'!

!EstadoViva methodsFor: 'as yet unclassified' stamp: 'Federico 11/1/2015 14:39'!
cambiarEstado: unaHormiga! !

!EstadoViva methodsFor: 'as yet unclassified' stamp: 'Federico 11/1/2015 14:41'!
comidaEstado

	 ^1! !

!EstadoViva methodsFor: 'as yet unclassified' stamp: 'Federico 11/1/2015 14:40'!
extraerDe: unaComida con: unaHormiga
	! !

!EstadoViva methodsFor: 'as yet unclassified' stamp: 'Federico 11/1/2015 14:40'!
llevarAlimentoA: unHormiguero con: unaHormiga

	unaHormiga moveteA: (unHormiguero ubicacion).
	
	unaHormiga almacenarComidaEn: unHormiguero! !

!EstadoViva methodsFor: 'as yet unclassified' stamp: 'Federico 11/1/2015 14:40'!
moveteA: unaUbicacion1 una: hormigaAfectada! !

!EstadoViva methodsFor: 'as yet unclassified' stamp: 'Federico 11/1/2015 14:39'!
puedeLlevarConEstado: unaHormiga

	^false! !

Object subclass: #Expedicion
	instanceVariableNames: 'hormigas hormiguero comidaQueSeBuscaEnLaExpedicion'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BICHOS'!

!Expedicion methodsFor: 'as yet unclassified' stamp: 'Federico 11/1/2015 16:47'!
comidaQueSeBuscaEnLaExpedicion

	^comidaQueSeBuscaEnLaExpedicion! !

!Expedicion methodsFor: 'as yet unclassified' stamp: 'Federico 11/1/2015 16:47'!
comidaQueSeBuscaEnLaExpedicion: unaComida

	comidaQueSeBuscaEnLaExpedicion:= unaComida! !

!Expedicion methodsFor: 'as yet unclassified' stamp: 'Federico 11/2/2015 23:23'!
concretar

	
	self estaDesarmada  ifFalse:[  
	self hormigas do:[:unaHormiga| unaHormiga extraerAlimentoDe: self comidaQueSeBuscaEnLaExpedicion ].
	self hormigas do:[:unaHormiga| unaHormiga descansa].
	self hormigas do:[:unaHormiga| unaHormiga moveteA: (self hormiguero ubicacion)  ].
	]
! !

!Expedicion methodsFor: 'as yet unclassified' stamp: 'Federico 11/1/2015 17:00'!
desarmar

	(self estaDesarmada) ifFalse: [ 
	self hormiguero agregarUnConjuntoDeHormigas:self hormigas. 
	self hormigas removeAll.
	]
! !

!Expedicion methodsFor: 'as yet unclassified' stamp: 'Federico 11/1/2015 16:38'!
estaDesarmada

	^self hormigas isEmpty! !

!Expedicion methodsFor: 'as yet unclassified' stamp: 'Federico 11/1/2015 16:34'!
hormigas


	^ hormigas.! !

!Expedicion methodsFor: 'as yet unclassified' stamp: 'Federico 11/1/2015 16:34'!
hormigas: anObject

	hormigas := anObject! !

!Expedicion methodsFor: 'as yet unclassified' stamp: 'Federico 11/1/2015 16:34'!
hormiguero


	^ hormiguero! !

!Expedicion methodsFor: 'as yet unclassified' stamp: 'Federico 11/1/2015 16:34'!
hormiguero: anObject


	hormiguero := anObject! !

Object subclass: #Hormiguero
	instanceVariableNames: 'depositoDeComida hormigasTotales ubicacion hormigas'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BICHOS'!

!Hormiguero methodsFor: 'as yet unclassified' stamp: 'Federico 10/31/2015 11:36'!
agregarComida: unaCantidad

	self depositoDeComida: self depositoDeComida + unaCantidad.! !

!Hormiguero methodsFor: 'as yet unclassified' stamp: 'Federico 10/26/2015 17:01'!
agregarHormiga: unaHormiga

	self hormigasTotales add: unaHormiga.! !

!Hormiguero methodsFor: 'as yet unclassified' stamp: 'Federico 11/1/2015 16:40'!
agregarUnConjuntoDeHormigas: unConjuntoDeHormigas


		self hormigasTotales addAll: unConjuntoDeHormigas.! !

!Hormiguero methodsFor: 'as yet unclassified' stamp: 'Federico 10/26/2015 19:14'!
cantidadHormigasTotales

	^hormigasTotales size.! !

!Hormiguero methodsFor: 'as yet unclassified' stamp: 'Federico 10/26/2015 17:23'!
comidaEnTotal

	^depositoDeComida + self comidaRecolectada.! !

!Hormiguero methodsFor: 'as yet unclassified' stamp: 'Federico 10/30/2015 23:35'!
comidaRecolectada

	^ hormigasTotales sum: [: hormiga | hormiga comidaQueLleva]! !

!Hormiguero methodsFor: 'as yet unclassified' stamp: 'Federico 11/1/2015 16:18'!
defenderseDelIntruso: unIntruso

self hormigasAtacantes do:[:hormiga|hormiga atacar: unIntruso]! !

!Hormiguero methodsFor: 'as yet unclassified' stamp: 'Federico 10/26/2015 17:11'!
depositoDeComida

	^depositoDeComida.! !

!Hormiguero methodsFor: 'as yet unclassified' stamp: 'Federico 10/26/2015 17:22'!
depositoDeComida: anObject

	depositoDeComida := anObject! !

!Hormiguero methodsFor: 'as yet unclassified' stamp: 'Federico 11/1/2015 12:20'!
diezHormigas

	^ (hormigasTotales asArray) copyFrom: 1 to: 10! !

!Hormiguero methodsFor: 'as yet unclassified' stamp: 'Federico 11/1/2015 02:47'!
estaAMenosDeDosMetros:unBicho


	^((unBicho ubicacion) distanciaA: self ubicacion )<2! !

!Hormiguero methodsFor: 'as yet unclassified' stamp: 'Federico 10/26/2015 18:29'!
hormigasTotales
	
	^ hormigasTotales.! !

!Hormiguero methodsFor: 'as yet unclassified' stamp: 'Federico 10/26/2015 19:03'!
hormigasTotales: anObject 

	hormigasTotales:= anObject 	! !

!Hormiguero methodsFor: 'as yet unclassified' stamp: 'Federico 10/26/2015 19:15'!
initialize

	hormigasTotales:= Bag new.
	depositoDeComida:=0.! !

!Hormiguero methodsFor: 'as yet unclassified' stamp: 'Federico 11/1/2015 02:51'!
intruso: unBicho

^((self tieneA: unBicho)not) & (self estaAMenosDeDosMetros: unBicho)  . ! !

!Hormiguero methodsFor: 'as yet unclassified' stamp: 'Federico 10/31/2015 00:06'!
juntarAlimento


	self hormigasTotales do:[: unaHormiga | unaHormiga llevarComidaA: self].
	! !

!Hormiguero methodsFor: 'as yet unclassified' stamp: 'Federico 11/1/2015 11:25'!
removerMuerta: unaHormiga

	self hormigasTotales remove: unaHormiga! !

!Hormiguero methodsFor: 'as yet unclassified' stamp: 'Federico 11/1/2015 02:49'!
tieneA: unBicho

	^(self hormigasTotales) includes: unBicho.! !

!Hormiguero methodsFor: 'as yet unclassified' stamp: 'Federico 10/26/2015 19:08'!
ubicacion
	
	^ ubicacion.! !

!Hormiguero methodsFor: 'as yet unclassified' stamp: 'Federico 10/26/2015 19:08'!
ubicacion: unaUbicacion

	ubicacion := unaUbicacion.! !

Hormiguero subclass: #Hormiguero10Hormigas
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BICHOS'!

!Hormiguero10Hormigas methodsFor: 'as yet unclassified' stamp: 'Federico 11/1/2015 12:27'!
hormigasAtacantes: unHormiguero

	^ unHormiguero diezHormigas ! !

Hormiguero subclass: #Hormiguero500cm
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BICHOS'!

!Hormiguero500cm methodsFor: 'as yet unclassified' stamp: 'Federico 11/1/2015 12:28'!
hormigasAtacantes


	self hormigasTotales select: [:hormiga | hormiga a500cmDe: (self ubicacion)]! !

Hormiguero subclass: #HormigueroViolento
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BICHOS'!

!HormigueroViolento methodsFor: 'as yet unclassified' stamp: 'Federico 11/1/2015 12:28'!
hormigasAtacantes

	^self hormigasTotales select:[:hormiga|hormiga esViolenta]! !

Object subclass: #Ubicacion
	instanceVariableNames: 'coordenada1 coordenada2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BICHOS'!

!Ubicacion methodsFor: 'as yet unclassified' stamp: 'Federico 10/31/2015 00:24'!
coordenada1

	^coordenada1 ! !

!Ubicacion methodsFor: 'as yet unclassified' stamp: 'Federico 10/31/2015 00:25'!
coordenada1: anObject

	coordenada1 := anObject! !

!Ubicacion methodsFor: 'as yet unclassified' stamp: 'Federico 10/31/2015 00:24'!
coordenada2

	^coordenada2! !

!Ubicacion methodsFor: 'as yet unclassified' stamp: 'Federico 10/31/2015 00:25'!
coordenada2: anObject

	coordenada2 := anObject! !

!Ubicacion methodsFor: 'as yet unclassified' stamp: 'Federico 10/31/2015 01:40'!
distanciaA: unaUbicacion

	^(((coordenada1-(unaUbicacion coordenada1))raisedTo:2)+ (((coordenada2 - (unaUbicacion coordenada2)) raisedTo:2 )))sqrt.
! !
